    /**
     * @file play-toggle.js
     */
    import Button from '../button.js';
    import Component from '../component.js';

    /**
     * Button to toggle between play and pause.
     *
     * @extends Button
     */
    class PlayToggle extends Button {

      /**
       * Creates an instance of this class.
       *
       * @param {Player} player
       *        The `Player` that this class should be attached to.
       *
       * @param {Object} [options]
       *        The key/value store of player options.
       */
      constructor(player, options) {
        super(player, options);

        this.on(player, 'play', this.handlePlay);
        this.on(player, 'pause', this.handlePause);
        this.on(player, 'ended', this.handleEnded);
      }

      /**
       * Builds the default DOM `className`.
       *
       * @return {string}
       *         The DOM `className` for this object.
       */
      buildCSSClass() {
        return `vjs-play-control ${super.buildCSSClass()}`;
      }

      /**
       * This gets called when an `PlayToggle` is "clicked". See
       * {@link ClickableComponent} for more detailed information on what a click can be.
       *
       * @param {EventTarget~Event} [event]
       *        The `keydown`, `tap`, or `click` event that caused this function to be
       *        called.
       *
       * @listens tap
       * @listens click
       */
      handleClick(event) {
        if (this.player_.paused()) {
          this.player_.play();
        } else {
          this.player_.pause();
        }
      }

      /**
       * Add the vjs-playing class to the element so it can change appearance.
       *
       * @param {EventTarget~Event} [event]
       *        The event that caused this function to run.
       *
       * @listens Player#play
       */
      handlePlay(event) {
        this.removeClass('vjs-ended');
        this.removeClass('vjs-paused');
        this.addClass('vjs-playing');
        // change the button text to "Pause"
        this.controlText('Pause');
      }

      /**
       * Add the vjs-paused class to the element so it can change appearance.
       *
       * @param {EventTarget~Event} [event]
       *        The event that caused this function to run.
       *
       * @listens Player#pause
       */
      handlePause(event) {
        this.removeClass('vjs-playing');
        this.addClass('vjs-paused');
        // change the button text to "Play"
        this.controlText('Play');
      }

      /**
       * Add the vjs-ended class to the element so it can change appearance
       *
       */
      handleEnded(event) {
        this.removeClass('vjs-playing');
        this.addClass('vjs-ended');
        // change the button text to "Replay"
        this.controlText('Replay');
      }
    }

    /**
     * The text that should display over the `PlayToggle`s controls. Added for localization.
     *
     * @type {string}
     * @private
     */
    PlayToggle.prototype.controlText_ = 'Play';

    Component.registerComponent('PlayToggle', PlayToggle);
    export default PlayToggle;